#
# spec file for package iscsitarget (Version 0.4.17)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           iscsitarget
BuildRequires:  kernel-syms module-init-tools openssl-devel
Url:            http://iscsitarget.sourceforge.net
License:        GPLv2
Group:          System/Daemons
PreReq:         %fillup_prereq %insserv_prereq /bin/cat /bin/rm
AutoReqProv:    on
Version:        0.4.17
Release:        4.5.1
Requires:       iscsitarget-kmp
Summary:        Open Source iSCSI Target with Professional Features
Source:         %{name}-%{version}.tar.gz
Source1:        %{name}.init
Source2:        preamble
Source3:        services
Patch0:         iscsitarget-2.6.29.patch
Patch1:         iscsitarget-2.6.30.patch
Patch2:         iscsitarget-0.4.17.diff
Patch3:         iscsitarget-isns-bounds-checking
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%suse_kernel_module_package -n %{name} -p %{S:2} kdump um

%description
The aim of the project is to develop an open source iSCSI target with
professional features that works well in enterprise environment under
real workload and is scalable and versatile enough to meet the
challenge of future storage needs and developments.



Authors:
--------
    iscsitarget-devel@lists.sourceforge.net

%package KMP
Group:          System/Daemons
License:        LGPLv2.1+
Summary:        Open Source iSCSI Target with Professional Features

%description KMP
The aim of the project is to develop an open source iSCSI target with
professional features that works well in enterprise environment under
real workload and is scalable and versatile enough to meet the
challenge of future storage needs and developments.



Authors:
--------
    iscsitarget-devel@lists.sourceforge.net

%prep
%setup
%patch0
%patch1
%patch2 -p0
%patch3 -p1
echo "iscsi_trgt.ko yes" > kernel/Module.supported

%build
%{__make} CFLAGS="${RPM_OPT_FLAGS} -D_GNU_SOURCE -I../include" bindir=/usr/sbin -C usr
for flavor in %flavors_to_build; do
	rm -rf obj/$flavor
	mkdir -p obj/$flavor
	cp -a kernel/* obj/$flavor
	cp include/iet_u.h obj/$flavor
	make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
	      M=$PWD/obj/$flavor
done

%install
install -vD usr/ietd ${RPM_BUILD_ROOT}/usr/sbin/ietd
install -vD usr/ietadm ${RPM_BUILD_ROOT}/usr/sbin/ietadm
install -vD -m 600 etc/ietd.conf ${RPM_BUILD_ROOT}/etc/ietd.conf
install -vD -m 755 %{S:1} ${RPM_BUILD_ROOT}/etc/init.d/iscsitarget
install -vD -m 644 %{S:2} ${RPM_BUILD_ROOT}/etc/sysconfig/SuSEfirewall2.d/services/iscsitarget
install -D -m 644 doc/manpages/ietd.8 ${RPM_BUILD_ROOT}%{_mandir}/man8/ietd.8
install -D -m 644 doc/manpages/ietd.conf.5 ${RPM_BUILD_ROOT}%{_mandir}/man5/ietd.conf.5
ln -sf ../../etc/init.d/iscsitarget $RPM_BUILD_ROOT/usr/sbin/rciscsitarget
# install kernel modules
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
	make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
	      M=$PWD/obj/$flavor
done

%clean
[ "${RPM_BUILD_ROOT}" != "/" -a -d ${RPM_BUILD_ROOT} ] && rm -rf ${RPM_BUILD_ROOT}
rm -f filelist

%post
%{fillup_and_insserv -f iscsitarget}

%preun
%stop_on_removal iscsitarget

%postun
%{insserv_cleanup}

%files
%attr(755,root,root)/usr/sbin/*
%attr(755,root,root)/etc/init.d/*
%defattr(-,root,root)
%config /etc/ietd.conf
%config /etc/sysconfig/SuSEfirewall2.d/services/*
%doc COPYING README
%doc %{_mandir}/man5/*
%doc %{_mandir}/man8/*

%changelog
* Thu Aug  5 2010 hare@suse.de
- Fixup bounds checking for iSNS (bnc#618574)
* Fri Jun 12 2009 coolo@novell.com
- fix build with glibc 2.10
* Mon Jun  8 2009 ro@suse.de
- fix build with 2.6.30
* Mon Apr 20 2009 ro@suse.de
- fix build with current kernel 2.6.29
  - NIP4 and NIP6 are repaced by special printf pointer formats
  - open_bdev_excl and close_bdev_excl renamed to _exclusive
* Mon Apr 20 2009 ro@suse.de
- update to 0.4.17
  o handle the \0-termination of strings properly when building iSNS TLVs
  o fix stopping of wthreads that have never been awakened
  o fix debugging code that hexdumps PDU content to the syslog
  o avoid busy looping if a connection's socket is out of wmem
  o add support for "ietadm --op show --user"
  o SCSI fixes: MODE SENSE handling, INQUIRY CmdDt, HiSup, WCE and RCD handling
  o fix handling of NOP-Out w/ ping data
  o fix compilation against glibc >= 2.8
  o fix potential NULL-pointer derefences and resource leaks in the LUN param
    parsing code
  o documentation updates
  o 2.6.26 and SLES compile fix
  o SLES 10 SP2 compat patch
  o make needlessly global function static
- update to 0.4.16
  o fix overzealous assert() in digest_data()
  o add checking on return value of ISCSI_PARAM_GET
  o 2.6.22, 2.6.23 and 2.6.24 compile fixes
  o add conn->rwsize check
  o avoid potential NULL-ptr dereferences in rx and tx buffer
  o fix the shell syntax in init scripts
  o fix digest endieness on LE archs
  o fix SPARC alignement issues (based on a patch from joel.bertrand@systella.fr)
  o fix DISTDIR in Makefile for /etc install
  o add support to nullio for volumes > 2TB
  o remove init.d memory size adjustment
  o add error code reporting to blockio_open_path
  o blockio gen_scsiid bug fix
  o add verbosity to kernel output and task management
* Mon Jan 26 2009 hare@suse.de
- Mark 'iscsi_trgt' as supported (bnc#439535)
- Add services file for SuSEfirewall2 (bnc#459904)
* Mon Jan 12 2009 dgollub@suse.de
- Add kernel-syms-rt to build requires to build SLERT KMPs
* Mon Oct 27 2008 hare@suse.de
- Add missing 'preamble' file for KMP.
* Fri Oct 24 2008 hare@suse.de
- Fix up changelog and spec file.
* Tue Oct 21 2008 hare@suse.de
- Update to svn r174
  * Build fixes for 2.6.27 (bnc#436990)
  * Misc bug fixes
- Fix spec file to correctly reference KMPs (bnc#436988)
* Thu Aug 28 2008 ro@suse.de
- fix init script
* Wed Jul 30 2008 ro@suse.de
- grab patch from svn to make it build with current kernel
* Tue Nov 27 2007 ro@suse.de
- marked kmp preamble as source file
* Tue Nov 27 2007 ro@suse.de
- make it build with 2.6.24
* Tue Oct 23 2007 ro@suse.de
- add KMP subpackage to transport metadata for kmp subpacks
* Sat Oct 20 2007 jeffm@suse.com
- Update to 0.4.15
  - Improved error reporting with fileio_sync()
  - Rewritten iSNS code with many fixes
  - Fix bug in READ_* commands error handling
  - Fix mode sense response.
- Added building of KMP to spec file.
* Wed May 31 2006 hare@suse.de
- Pull in fixes from upstream to prevent kernel oops [#179557]
* Mon May 22 2006 hare@suse.de
- Set mode for /etc/ietd.conf to 600 [#177081]
* Thu May 18 2006 kukuk@suse.de
- Fix return code of init script [#176186]
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Jan 13 2006 hare@suse.de
- Update to official version 0.4.13
* Thu Nov  3 2005 hare@suse.de
- Update to svn r1262, version 0.4.13
* Sun Sep 11 2005 aj@suse.de
- Correct rciscsitarget link.
- Do not depend on kernel-source and kernel-syms since those are
  not needed.
* Wed Sep  7 2005 hare@suse.de
- Update to svn r1247
- Fix init script (#114386)
* Wed Jul  6 2005 hare@suse.de
- Initial version 0.4.11
